/******************************************************************
Archivo Lienzo.js
Sistema Propano
"Dale gas..."
Autor: Adrian Kosmaczewski
Fecha: 06 de junio de 2004
Version: 1.0


Sistema Propano - Un sistema simple de gestion de contenidos web.
Copyright (C) 2004 - Adrian Kosmaczewski

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

NeXT, the NeXT Cube 	Logo, Objective-C and other related names
are trademarks of NeXT Software Inc. and/or Apple Computer Inc.

For more information please refer to:
http://www.apple.com/legal/nexttmlist.html
*/

/******************************************************************
Clase Lienzo
Esta clase, de la cual tambien hay una sola instancia por pagina,
coordina lo que sucede en la misma; inicializacion, variables globales,
etc.
*/
function Lienzo()
{
	// El mundo de los browsers esta dividido en dos: 
	// Internet Explorer 4+ y Opera (IE)
	// y Mozilla y Safari (W3C)
	var bExplorer = false;
	var bMozilla = false;
	var iAltoPantalla = 0;
	var iAnchoPantalla = 0;
	
	inicializar();
	
	this.ejecutarComando = function(sComando)
	{
		Menusero.instancia.ocultarTodos();
		switch (sComando)
		{
			case "ArchivoAbrir":
				cargarDocumento('servidor/xml/documento.xml', 'test');
				break;
				
			case "VentanasCrear":
				crearNuevaVentana();
				break;
				
			case "VentanasAchicar":
				Vidriero.instancia.achicarTodas();
				break;
				
			case "VentanasAgrandar":
				Vidriero.instancia.agrandarTodas();
				break;
				
			case "VentanasCerrar":
				Vidriero.instancia.cerrarTodas();
				break;
				
			case "VentanasCrearMuchas":
				crearMuchasVentanas(25);
				break;
				
			default:
				break;
		}
	}
	
	this.preparar = function() 
	{
		prepararEventos();
		obtenerDimensiones();
		
		// Posicionar los iconos
		var oIconos = document.getElementById("Iconos");
		oIconos.style.top = "0px";
		oIconos.style.left = (iAnchoPantalla - 65).toString() + "px";
		
		// Posicionar la pantalla de bienvenida
		var oBienvenidos = document.getElementById("Bienvenidos");
		oBienvenidos.style.visibility = "visible";
		oBienvenidos.style.top = ((iAltoPantalla / 2) - 139).toString() + "px";
		oBienvenidos.style.left = ((iAnchoPantalla / 2) - 250).toString() + "px";
	}
	
	this.isInternetExplorer = function()
	{
		return bExplorer;
	}
	
	this.isMozilla = function()
	{
		return bMozilla;
	}
	
	this.anchoPantalla = function()
	{
		return iAnchoPantalla;
	}
	
	this.altoPantalla = function()
	{
		return iAltoPantalla;
	}
	
	function obtenerDimensiones()
	{
		// Setear el ancho y el alto de la pantalla 
		// (esto se usara para colocar los iconos en la pantalla)
		if (bMozilla)
		{
			iAltoPantalla = self.innerHeight - 20;
			iAnchoPantalla = self.innerWidth - 20;
		}
		if (bExplorer)
		{
			iAltoPantalla = document.body.clientHeight - 20;
			iAnchoPantalla = document.body.clientWidth - 20;
		}
	}
	
	function prepararEventos()
	{
		// Captura de eventos
		if (bMozilla)
		{
			document.captureEvents(Event.MOUSEDOWN | Event.MOUSEUP | Event.ONCONTEXTMENU);
		}
		
		document.onmousedown = startDrag;
		document.onmouseup = endDrag;
		
		// Por el momento, no hacer nada en caso de click con el boton derecho
		// del mouse; en un futuro se podra hacer un menu contextual privado...
		document.oncontextmenu = function()
		{
			return false;
		}
		
		document.body.onclick = function(e)
		{	
			var trg = null;
			if (!e) e = window.event;
			if (e.target)
			{
				trg = e.target;
			}
			else if (e.srcElement) 
			{
				trg = e.srcElement;
			}
		
			if (trg.tagName == "BODY")
			{
				Menusero.instancia.ocultarTodos();
			}
		}	
	}
	
	function inicializar()
	{
		// Primero veamos con que Browser estamos trabajando.
		if ((navigator.appName.indexOf("Netscape") != -1) && (parseInt(navigator.appVersion) >= 5)) 
		{
				// Netscape 6, Mozilla, Safari
				bMozilla = true;
		}
		else
		{ 
			if ((navigator.appName.indexOf("Microsoft") != -1) && (parseInt(navigator.appVersion) >= 4))
			{
				// MSIE 4.x o mayor
				bExplorer = true;
			}
			if (navigator.userAgent.indexOf("Opera 5") != -1)
			{
				// Opera 5.x - se maneja como si fuese Internet Explorer
				bExplorer = true;
			}
		}
	
	}
}

Lienzo.instancia = new Lienzo();

function cargarDocumento(sDocumentoURL, sNombreVentana)
{
	Vidriero.instancia.abrirVentana(sNombreVentana);
	Navegador.instancia.abrirDocumento(sDocumentoURL);
}

function mostrarMenu(e)
{
	var trg = null;
	if (!e) e = window.event;
	if (e.target)
	{
		if (e.currentTarget && (e.currentTarget != e.target))
		{
			trg = e.currentTarget;
		}
		else
		{
			trg = e.target;
		}
	}
	else if (e.srcElement) 
	{
		trg = e.srcElement.parentElement;
	}
	
	var sId = trg.id.split("_")[0];
	Menusero.instancia.mostrarMenu(sId);
}

function crearNuevaVentana()
{
	var sNombre = window.prompt("Ingrese el nombre de la nueva ventana", "");
	if (sNombre && (sNombre != ""))
	{
		Vidriero.instancia.abrirVentana(sNombre);
	}
}

function entrar()
{
	document.getElementById("Bienvenidos").style.display = "none";
	document.getElementById("Iconos").style.visibility = "visible";
	document.getElementById("Propano_PanelMenu").style.visibility = "visible";
}

// Este metodo es ejecutado cuando se termina de cargar 'documento.xml' o
// cualquier otro documento.
Navegador.documentoListo = function()
{
	var oVentana = Vidriero.instancia.obtenerVentanaPorNombre('test');
	var oJavaScript = Navegador.instancia.documentoJS();
	oVentana.ponerContenido(oJavaScript.datos.contenidos);
	oVentana.ponerTitulo(oJavaScript.metadatos.titulo);
	Vidriero.instancia.ponerEnPrimerPlano('test');
	// window.prompt("", oVentana.obtenerHTML());
}

function crearMuchasVentanas(iCantidad)
{
	var iMinimo = Vidriero.instancia.cantidadDeVentanas();
	iCantidad += iMinimo;
	for (var i = iMinimo; i < iCantidad; i++)
	{
		Vidriero.instancia.abrirVentana(i.toString());
	}
}
