/******************************************************************
Archivo Rastrero.js
Sistema Propano
"Dale gas..."
Autor: Adrian Kosmaczewski
Fecha: 06 de junio de 2004
Version: 1.0


Sistema Propano - Un sistema simple de gestion de contenidos web.
Copyright (C) 2004 - Adrian Kosmaczewski

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

NeXT, the NeXT Cube 	Logo, Objective-C and other related names
are trademarks of NeXT Software Inc. and/or Apple Computer Inc.

For more information please refer to:
http://www.apple.com/legal/nexttmlist.html
*/

/******************************************************************
Este script esta adaptado (y traducido del aleman) del que aparece en la pagina
http://www.dpunkt.de/javascript/bsp/script2/dragdrop/index.html

Fue probado con exito en los siguientes browsers:
- Apple Safari 1.2
- Mozilla 1.6 Windows y Mac (Firefox, Camino, etc.)
- Internet Explorer 5.2 Mac
- Internet Explorer 6 Windows

Su utilidad reside en su extensibilidad, ya que no necesita
registrar handlers directamente sobre los objetos sino que trabaja a
nivel del documento atrapando eventos.

Se elimino de este script el soporte para Netscape 4.
*/

var dx = 0, dy = 0;
var oObjetoActivo = null;

/*
Proposito: Es llamada cuando se detecta el evento onmousedown,
           es decir cuando el usuario aprieta el boton del mouse
           sobre algun objeto en la pagina.
Entrada:   Un objeto que representa el evento.
Salida:    Ninguna.
*/
function startDrag(e) 
{
	if (Lienzo.instancia.isMozilla()) 
	{
		// Objeto que recibe el evento
		var obj = e.target;

		// Si se hace click sobre la barra de titulo de una ventana,
		// lo que nos interesa es mover el resto de la ventana...
		if  ((obj.id != null) && (obj.id.indexOf("Ventana_Titulo") != -1))
		{
			oObjetoActivo = obj.parentNode;

			dx = e.clientX - parseInt(oObjetoActivo.style.left);
			dy = e.clientY - parseInt(oObjetoActivo.style.top);

			// Enviar el objeto hacia arriba
			var sNombre = obj.parentNode.id;
			sNombre = sNombre.substring(Vidriero.PREFIJO_VENTANAS.length, sNombre.length);
			Vidriero.instancia.ponerEnPrimerPlano(sNombre);
      
	  		document.captureEvents(Event.MOUSEMOVE);
			document.onmousemove = drag;
			return false;
		}

		// Esto es para poder desplazar los iconos de las ventanas
		if  ((obj.id != null) && (obj.id.indexOf(Vidriero.PREFIJO_ICONOS) != -1))
		{
			oObjetoActivo = obj;

			dx = e.clientX - parseInt(oObjetoActivo.style.left);
			dy = e.clientY - parseInt(oObjetoActivo.style.top);

			// Enviar el objeto hacia arriba
			oObjetoActivo.style.zIndex = Vidriero.instancia.aumentarZIndexTop();
      
	  		document.captureEvents(Event.MOUSEMOVE);
			document.onmousemove = drag;
			return false;
		}

		// Esto es para poder desplazar los menus
		if  ((obj.id != null) && (obj.className.indexOf("Menu") != -1))
		{
			oObjetoActivo = obj.parentNode.parentNode.parentNode.parentNode;

			dx = e.clientX - parseInt(oObjetoActivo.style.left);
			dy = e.clientY - parseInt(oObjetoActivo.style.top);
			
			// Enviar el objeto hacia arriba
			oObjetoActivo.style.zIndex = Vidriero.instancia.aumentarZIndexTop();
      
	  		document.captureEvents(Event.MOUSEMOVE);
			document.onmousemove = drag;
			return false;
		}

		// Esto es para poder redimensionar las ventanas
		if  ((obj.id != null) && (obj.className.indexOf("BarraInferior") != -1))
		{
			oObjetoActivo = obj.parentNode;

			dx = e.clientX - parseInt(oObjetoActivo.style.left);
			dy = e.clientY - parseInt(oObjetoActivo.style.top);

			// Enviar el objeto hacia arriba
			var sNombre = obj.parentNode.id;
			sNombre = sNombre.substring(Vidriero.PREFIJO_VENTANAS.length, sNombre.length);
			Vidriero.instancia.ponerEnPrimerPlano(sNombre);
      
	  		document.captureEvents(Event.MOUSEMOVE);
			document.onmousemove = resize;
			return false;
		}
	}
	
	if (Lienzo.instancia.isInternetExplorer())
	{
		// Objeto que recibe el evento
		var obj = window.event.srcElement;
		
		// Si se hace click sobre la barra de titulo de una ventana,
		// lo que nos interesa es mover el resto de la ventana...
		if ((obj != null) && (obj.id.indexOf("Ventana_Titulo") != -1)) 
		{
			oObjetoActivo = obj.parentElement;
      
			dx = window.event.clientX - oObjetoActivo.style.pixelLeft;
			dy = window.event.clientY - oObjetoActivo.style.pixelTop;
		
			// Enviar el objeto hacia arriba
			var sNombre = obj.parentElement.id;
			sNombre = sNombre.substring(Vidriero.PREFIJO_VENTANAS.length, sNombre.length);
			Vidriero.instancia.ponerEnPrimerPlano(sNombre);
      
			document.onmousemove = drag;
			return false;
		}
		
		// Esto es para poder desplazar los iconos de las ventanas
		if ((obj != null) && (obj.id.indexOf(Vidriero.PREFIJO_ICONOS) != -1)) 
		{
			oObjetoActivo = obj;
      
			dx = window.event.clientX - oObjetoActivo.style.pixelLeft;
			dy = window.event.clientY - oObjetoActivo.style.pixelTop;
			
			// Enviar el objeto hacia arriba
			oObjetoActivo.style.zIndex = Vidriero.instancia.aumentarZIndexTop();
      
			document.onmousemove = drag;
			return false;
		}

		// Esto es para poder desplazar los menues
		if ((obj != null) && (obj.className.indexOf("Menu") != -1)) 
		{
			oObjetoActivo = obj.parentElement.parentElement.parentElement.parentElement;
      
			dx = window.event.clientX - oObjetoActivo.style.pixelLeft;
			dy = window.event.clientY - oObjetoActivo.style.pixelTop;
		
			// Enviar el objeto hacia arriba
			oObjetoActivo.style.zIndex = Vidriero.instancia.aumentarZIndexTop();
      
			document.onmousemove = drag;
			return false;
		}
		
		// Esto es para poder redimensionar las ventanas
		if  ((obj != null) && (obj.className.indexOf("BarraInferior") != -1))
		{
			oObjetoActivo = obj.parentElement;

			dx = window.event.clientX - parseInt(oObjetoActivo.style.pixelLeft);
			dy = window.event.clientY - parseInt(oObjetoActivo.style.pixelTop);

			// Enviar el objeto hacia arriba
			var sNombre = obj.parentElement.id;
			sNombre = sNombre.substring(Vidriero.PREFIJO_VENTANAS.length, sNombre.length);
			Vidriero.instancia.ponerEnPrimerPlano(sNombre);
      
			document.onmousemove = resize;
			return false;
		}
	}

	// El usuario no hizo click sobre nada
	oObjetoActivo = null;

	// Si se pone return false aqui, Safari no permite hacer
	// scrolling en un DIV...
	return true;
}

/*
Proposito: Es llamada cuando se detecta el evento onmousemove
Entrada:   Un objeto que representa el evento.
Salida:    Ninguna.
*/
function drag(e)
{
	if (oObjetoActivo != null)
	{
		if (Lienzo.instancia.isMozilla())
		{
			oObjetoActivo.style.top = parseInt(e.clientY) - dy;
			oObjetoActivo.style.left = parseInt(e.clientX) - dx;
		}
		if (Lienzo.instancia.isInternetExplorer())
		{
			oObjetoActivo.style.pixelTop = window.event.clientY - dy;
			oObjetoActivo.style.pixelLeft = window.event.clientX - dx;
		}
	}
  
	return false;
}

/*
Proposito: Maneja el redimensionamiento de la ventana cuando se hace un
           drag and drop de la barra inferior de la ventana.
Entrada:   Un objeto que representa un evento.
Salida:    Ninguna.
*/
function resize(e)
{
	if (oObjetoActivo != null)
	{
		if (Lienzo.instancia.isMozilla())
		{
			dx = e.clientX - parseInt(oObjetoActivo.style.left);
			dy = e.clientY - parseInt(oObjetoActivo.style.top);
			var iAncho = parseInt(dx);
			var iAlto = parseInt(dy);
			var oVentana = Vidriero.instancia.obtenerVentanaPorDiv(oObjetoActivo);
			if (oVentana)
			{
				oVentana.cambiarTamanio(iAncho, iAlto);
			}
		}

		if (Lienzo.instancia.isInternetExplorer())
		{
			dx = window.event.clientX - parseInt(oObjetoActivo.style.pixelLeft);
			dy = window.event.clientY - parseInt(oObjetoActivo.style.pixelTop);
			var iAncho = parseInt(dx);
			var iAlto = parseInt(dy);
			var oVentana = Vidriero.instancia.obtenerVentanaPorDiv(oObjetoActivo);
			if (oVentana)
			{
				oVentana.cambiarTamanio(iAncho, iAlto);
			}
		}
	}
}

/*
Proposito: Es llamada cuando se detecta el evento onmouseup,
           es decir cuando el usuario levanta el boton del mouse.
Entrada:   Un objeto que representa el evento.
Salida:    Ninguna.
*/
function endDrag(e)
{
	if (Lienzo.instancia.isMozilla()) 
	{
		document.releaseEvents(Event.MOUSEMOVE);
	}
	
	document.onmousemove = null;
	oObjetoActivo = null;
  
	return false;
}
