<?php
/******************************************************************
Archivo index.php
Sistema Propano
"Dale gas..."
Autor: Adrian Kosmaczewski
Fecha: 13 de junio de 2004
Version: 1.0

Sistema Propano - Un sistema simple de gestion de contenidos web.
Copyright (C) 2004 - Adrian Kosmaczewski

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

NeXT, the NeXT Cube 	Logo, Objective-C and other related names
are trademarks of NeXT Software Inc. and/or Apple Computer Inc.

For more information please refer to:
http://www.apple.com/legal/nexttmlist.html
*/

/******************************************************************
Este archivo es el corazon del Sistema Propano
*/
require_once("servidor/php/xslt.php");
require_once("servidor/php/datos.php");

$oXSLT = new XSLT;
$oXSLT->archivoXML("servidor/xml/Menu.xml");
$oXSLT->archivoXSL("servidor/xml/Menu.xsl");
$sMenues = $oXSLT->transformar();

// Cambiar el XSLT pero usar el mismo XML de base
// para hacer los iconos
$oXSLT->archivoXSL("servidor/xml/Iconos.xsl");
$sIconos = $oXSLT->transformar();
$oXSLT->finalizar();

// Este script analiza el querystring y obtiene las variables necesarias
// y las pone en un array llamado $aParametros
function obtenerParametros()
{
	$sScriptActual = $_SERVER['PHP_SELF'];
	$sNombreDelArchivo = basename(__FILE__);
	$aPartes = explode('/', $sScriptActual);
	$bSeguir = false;
	$aParametrosRetorno = null;
	$i = 0;
	foreach ($aPartes as $sParte)
	{
		if ($bSeguir)
		{
			$aParametrosRetorno[$i++] = $sParte;
		}
		else
		{
			if ($sParte == $sNombreDelArchivo)
			{
				$bSeguir = true;
			}
			continue;
		}
	}
	return $aParametrosRetorno;
}

$aParametros = obtenerParametros();

switch (count($aParametros))
{
	case 0:
		break;
		
	case 1:
		$sParametro = $aParametros[0];
		$oDocumento = obtenerDocumento($sParametro);
		break;
		
	default:
		// Este codigo es necesario para cuando se piden la hoja de estilo,
		// los archivos Java y JavaScript, etc. Esto es porque el browser cree
		// que "index.php" es una carpeta...
		$sNombreArchivo = str_replace("index.php/", "", $_SERVER['PHP_SELF']);
		header("location: {$sNombreArchivo}");
		break;
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<head>

	<title>Propano - Adrian Kosmaczewski</title>

	<meta http-equiv="cache-control" content="no-cache"/>
	<meta http-equiv="pragma" content="no-cache">
	<meta http-equiv="content-language" content="es-AR"/>
	<meta http-equiv="content-type" content="text/html; charset=utf-8"/>

	<meta name="author" content="Adrian Kosmaczewski"/>
	<meta name="copyright" content="&copy; 2004 Adrian Kosmaczewski"/>
	<meta name="description" content="Pagina personal de Adrian Kosmaczewski, programador y consultor en Ginebra, Suiza"/>
	<meta name="keywords" content="Argentina, Suiza, Propano, Java, JavaScript, .NET, C#, Objective-C, Cocoa, DHTML, CSS, Fenolico"/>
	<meta name="googlebot" content="noarchive"/>
	<meta name="robots" content="index,follow"/>

	<script language="JavaScript" type="text/javascript" src="cliente/javascript/Navegador.js"></script>
	<script language="JavaScript" type="text/javascript" src="cliente/javascript/Vidriero.js"></script>
	<script language="JavaScript" type="text/javascript" src="cliente/javascript/Rastrero.js"></script>
	<script language="JavaScript" type="text/javascript" src="cliente/javascript/Menusero.js"></script>
	<script language="JavaScript" type="text/javascript" src="cliente/javascript/Lienzo.js"></script>

	<link rel="stylesheet" type="text/css" href="cliente/css/NeXT.css"/>

</head>

<body onload="Lienzo.instancia.preparar()">

<div id="Bienvenidos" class="Bienvenidos" onclick="entrar()"></div>

<?php
// Escribir menues e iconos
echo $sMenues;
echo $sIconos;

if (count($aParametros) > 0)
{
	echo '<script language="JavaScript">entrar()</script>';
	
	if ($oDocumento)
	{
		$sTitulo = $oDocumento->obtenerTitulo();
		$sContenidos = $oDocumento->obtenerContenidos();
		printf('<div id="Ventana_1234" class="Ventana" style="left: 150px; top: 10px;"><div class="BarraTitulo" id="Ventana_Titulo_1234">%s</div><div class="Cerrar"></div><div class="Achicar"></div><div class="Contenidos">%s</div><div class="BarraInferior"></div></div>', $sTitulo, $sContenidos);
	}
}
?>

</body>
</html>
