<?php
/******************************************************************
Archivo datos.php
Sistema Propano
"Dale gas..."
Autor: Adrian Kosmaczewski
Fecha: 13 de junio de 2004
Version: 1.0

Sistema Propano - Un sistema simple de gestion de contenidos web.
Copyright (C) 2004 - Adrian Kosmaczewski

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

NeXT, the NeXT Cube 	Logo, Objective-C and other related names
are trademarks of NeXT Software Inc. and/or Apple Computer Inc.

For more information please refer to:
http://www.apple.com/legal/nexttmlist.html
*/

require_once("database.php");
require_once("documento.php");

/******************************************************************
Este archivo encapsula el acceso a la base de datos, proporcionando metodos
de sintaxis simple para cumplir con tareas basicas de lectura y escritura.
*/

/*
Proposito: Busca el documento cuyo numero se pasa en parametro.
Entrada:   Un numero de documento.
Salida:    Una instancia de la clase Documento que contiene la ultima
           version publica del articulo solicitado.
*/
function obtenerDocumento($sId)
{
	// Variables que se usaran para rellenar el Documento que se devuelve
	$sTitulo = "";
	$sAutor = "";
	$sFechaCreacion = "";
	$sResumen = "";
	$sContenidos = "";
	$sArticuloId = "";

	// Consultas a la base de datos
	// Primero obtener el ID de la ultima version del articulo solicitado
	$sConsulta1 = "SELECT id FROM propano_articulo_versiones WHERE articulo_id = " . $sId . " ORDER BY fecha DESC LIMIT 1";
	$oConjuntoRegistros1 = ejecutarConsulta($sConsulta1);
	
	if ($oConjuntoRegistros1->cantidad() > 0)
	{
		while ($oRegistro1 = $oConjuntoRegistros1->proximoRegistro())
		{
			$sArticuloId = $oRegistro1['id'];
		}
		
		// Luego obtener el documento propiamente dicho
		$sConsulta2 = "SELECT part.titulo AS titulo, CONCAT(paut.nombre, ' ', paut.apellido) AS autor, part.fecha_creacion AS fecha_creacion, pav.resumen AS resumen, pav.contenidos AS contenidos "
		. "FROM propano_articulo_versiones AS pav "
		. "INNER JOIN propano_articulos AS part ON part.id = pav.articulo_id "
		. "INNER JOIN propano_autores AS paut ON paut.id = part.autor_id "
		. "WHERE pav.id = " . $sArticuloId . " AND pav.publico = 1 AND part.publico = 1 "
		. "ORDER BY pav.fecha DESC "
		. "LIMIT 1";
		$oConjuntoRegistros2 = ejecutarConsulta($sConsulta2);
	    
	    // Normalmente el pedido trae un solo registro...
	    if ($oConjuntoRegistros2->cantidad() > 0)
	    {
	        while ($oRegistro2 = $oConjuntoRegistros2->proximoRegistro())
	        {
	            $sTitulo = $oRegistro2['titulo'];
	            $sAutor = $oRegistro2['autor'];
	            $sFechaCreacion = $oRegistro2['fecha_creacion'];
	            $sResumen = $oRegistro2['resumen'];
	            $sContenidos = $oRegistro2['contenidos'];
	        }
	    }
	
		// Limpiar la memoria    
	    $oConjuntoRegistros2->finalizar();
	
		// Construir un objeto documento que contenga
		// toda la informacion que se encontro
		$oDocumento = new Documento($sId, $sTitulo, $sAutor, $sFechaCreacion, $sResumen, $sContenidos);
		
		// Devolver el documento
		return $oDocumento;
	}
	
	$oConjuntoRegistros1->finalizar();
}

?>
