<?xml version="1.0" encoding="utf-8" ?>
<!--
Archivo Iconos.xsl
Sistema Propano
"Dale gas..."
Autor: Adrian Kosmaczewski
Fecha: 05 de junio de 2004
Version: 1.0


Sistema Propano - Un sistema simple de gestion de contenidos web.
Copyright (C) 2004 - Adrian Kosmaczewski

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

NeXT, the NeXT Cube 	Logo, Objective-C and other related names
are trademarks of NeXT Software Inc. and/or Apple Computer Inc.

For more information please refer to:
http://www.apple.com/legal/nexttmlist.html

******************************************************************
Este archivo XSL contiene las reglas de transformacion que permiten
crear una serie de iconos usando como base el archivo Menu.xml.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" version="4.01" standalone="no" omit-xml-declaration="yes" 
	encoding="utf-8" media-type="text/html" indent="no" cdata-section-elements="" />
	
	<xsl:variable name="cantidadDeIconos" select="count(/Menuse/Menu/Item[not(@Icono='')]) + 1"/>

	<!-- Plantilla para la raiz del documento -->
	<xsl:template match="/">

		<div id="Iconos" style="width: 64px; position: absolute; display: block; visibility: hidden; left: 0px; top: 10px">
		
		<!-- El icono NeXT siempre tiene que aparecer primero -->
		<div id="Aplicacion_NeXT" style="background-image: url(cliente/imagenes/icono_next.jpg); width: 64px; height: 64px; position: absolute; display: block; left: 0px; top: 10px"></div>

		<!-- Luego agregamos el reloj, que es una clase Java -->
		<div id="Reloj" class="Reloj" style="width: 64px; height: 64px; position: absolute; display: block; left: 0px; top: 75px">
		<applet codebase="cliente/java/" code="NeXTClock.class" width="64" height="64" name="NeXTClock"></applet>
		</div>

			<!-- Luego procesamos solamente aquellos <Item> del menu
			que tienen un icono definido; los demas, no. -->
			<xsl:apply-templates select="/Menuse/Menu/Item[not(@Icono='')]"/>

		<div id="Icono_Reciclar">
			<xsl:attribute name="style">background-image: url(cliente/imagenes/icono_reciclar.jpg); width: 64px; height: 64px; position: absolute; display: block; left: 0px; top: <xsl:value-of select="($cantidadDeIconos * 65) + 75"/>px</xsl:attribute>
		</div>


		</div>

		
	</xsl:template>


	<!-- Plantilla que transforma cada <Item> que contiene un icono
	definido en un <DIV> con la informacion necesaria. -->
	<xsl:template match="/Menuse/Menu/Item">
		<div>
			<xsl:attribute name="style">background-image: url(cliente/imagenes/icono_<xsl:value-of select="@Icono"/>.jpg); width: 64px; height: 64px; position: absolute; display: block; left: 0px; top: <xsl:value-of select="(position() * 65) + 75"/>px</xsl:attribute>
			
			<!-- Con esto nos aseguramos que un doble click en el icono tenga el mismo
			efecto que un click en su correspondiente item de menu -->
			<xsl:attribute name="ondblclick">Lienzo.instancia.ejecutarComando('<xsl:value-of select="@ID"/>')</xsl:attribute>
			<xsl:attribute name="id">Icono_Aplicacion_<xsl:value-of select="@ID"/></xsl:attribute>
		</div>
	</xsl:template>

</xsl:stylesheet>
