<?xml version="1.0" encoding="utf-8" ?>
<!--
Archivo Menu.xsl
Sistema Propano
"Dale gas..."
Autor: Adrian Kosmaczewski
Fecha: 05 de junio de 2004
Version: 1.0


Sistema Propano - Un sistema simple de gestion de contenidos web.
Copyright (C) 2004 - Adrian Kosmaczewski

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

NeXT, the NeXT Cube 	Logo, Objective-C and other related names
are trademarks of NeXT Software Inc. and/or Apple Computer Inc.

For more information please refer to:
http://www.apple.com/legal/nexttmlist.html

******************************************************************
Este archivo XSL contiene las reglas de transformacion que permiten
crear un menu DHTML compatible con la clase JavaScript Menusero
usando como base el archivo Menu.xml.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" version="4.01" standalone="no" omit-xml-declaration="yes" 
	encoding="utf-8" media-type="text/html" indent="no" cdata-section-elements="" />

	<!-- Plantilla para la raiz del archivo Menu.xml -->
	<xsl:template match="/">
		<!-- Procesar los subelementos Menu -->
		<xsl:apply-templates/>
	</xsl:template>

	<!-- Plantilla para los elementos Menu -->
	<xsl:template match="Menu">

		<!-- El menu propiamente dicho -->
		<div class="Menu" style="left: 10px; top: 10px;">
			<xsl:attribute name="id"><xsl:value-of select="@ID"/>_PanelMenu</xsl:attribute>
		<table class="Menu" cellspacing="0" cellpadding="0">
		<tr><td class="TituloMenu" colspan="2">
			
			<!-- Si es un menu de tipo principal, entonces, al moverlo, 
			se tienen que cerrar los submenues -->
			<xsl:if test="@EsPrincipal = 'Si'">
				<xsl:attribute name="onmousedown">Menusero.instancia.ocultarTodos()</xsl:attribute>
			</xsl:if>

			<!-- Titulo del menu -->
			<xsl:value-of select="@Titulo"/>
		</td></tr>	

			<!-- Procesar los subelementos Item -->
			<xsl:apply-templates/>
		</table>
		</div>
		
<!-- Script de creacion de los objetos JavaScript que manejaran estos DIV -->
<script language="JavaScript">
	<xsl:choose>
		<xsl:when test="@EsPrincipal='Si'">
Menusero.instancia.crearMenuPrincipal('<xsl:value-of select="@ID"/>');
		</xsl:when>
		<xsl:otherwise>
			<xsl:variable name="ID" select="@ID"/>
			
			<!-- Este XPath medio raro es para encontrar el atributo ID de aquel nodo
			Item que tiene definido el nodo actual como su SubMenu; de esta manera
			se genera el codigo JavaScript que indica: "tal submenu pertenece a 
			tal supermenu" -->
			<xsl:variable name="IDPadre" select="/Menuse/Menu/Item[@SubMenu=$ID]/../@ID"/>
Menusero.instancia.crearSubMenu('<xsl:value-of select="$ID"/>', '<xsl:value-of select="$IDPadre"/>');
		</xsl:otherwise>
	</xsl:choose>
</script>
		
	</xsl:template>
	
	<!-- Plantilla para los elementos <Item> -->
	<xsl:template match="Item">
		<tr class="Linea">
			<xsl:attribute name="id"><xsl:value-of select="@ID"/>_ItemMenu</xsl:attribute>
			
			<!-- Si tiene submenu, el click lleva a abrir el menu; de otra manera,
			lo que se hace es invocar el metodo Lienzo.instancia.ejecutarComando() pasando como parametro
			el identificador del menu. Estos dos metodos estan definidos en la clase Lienzo. -->
			<xsl:choose>
				<xsl:when test="@SubMenu=''">
			<xsl:attribute name="onclick">Lienzo.instancia.ejecutarComando('<xsl:value-of select="@ID"/>')</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
			<xsl:attribute name="onclick">mostrarMenu(event)</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			
			<!-- El texto del menu -->
			<td class="Texto">
				<xsl:value-of select="@Texto"/>
			</td><td>

				<!-- Si tiene submenu definido, poner la flecha -->
				<xsl:choose>
					<xsl:when test="@SubMenu=''">
						<xsl:attribute name="class">SinFlecha</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="class">Flecha</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>

				<!-- Esto es para Internet Explorer 6 Windows, que no muestra bien
				una celda vacia en una tabla -->
				<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
			</td>
		</tr>
	</xsl:template>

</xsl:stylesheet>
